#!/usr/bin/env python3
import pacmap
import os

from enum import IntEnum
from collections import namedtuple

_tempdir = namedtuple("Direction", ["up", "down", "left", "right"])
direction = _tempdir(
    up= (0, -1),
    down=(0, 1),
    left=(-1, 0),
    right=(1, 0)
)
pacdot_counter = 88
score = 0
lives = 3

# p-e à remplacer par la namedtuple direction plus haut
# class Direction(IntEnum):
#     U = 0
#     D = 1
#     R = 2
#     L = 3

class FruitType(IntEnum):
    A = 0

class Fruit:
    def __init__(self, fruit_type, score, position = (0, 0)):
        self.fruit_type = fruit_type
        self.score = score
        self.position = position


class Pacman:
    def __init__(self, position=[0, 0], map_size=(28, 31), resolution=10):
        self.position = [position[0]+int(resolution/2), position[1]+int(resolution/2)]
        self.direction = direction.right
        self.next_direction = direction.right
        self.super_power = 0                # Counter of super pacdots in effect (> 0 means super power is active)
        self.ghost_combo = 0
        self.size = (1.8, 1.8) # size related to tile size 
        self.speed = 0.1
        self.resolution = resolution # when pacman in 0:10 he's in the 1st cell if resolution=10
        self.map_size = map_size

    def matrix_position(self):
        # return (int(self.position[0]), int(self.position[1]))
        return int(self.position[0] / self.resolution), int(self.position[1] / self.resolution)
    
    def next_matrix_position(self):
        next_x = int(self.position[0] / self.resolution + self.direction[0]) % self.map_size[0]
        next_y = int(self.position[1] / self.resolution + self.direction[1]) % self.map_size[1]
        print(self.position, next_x, next_y)
        return next_x, next_y

    def has_super_power(self):
        return self.super_power > 0

    def eat_pacdot(self, dot_map):
        global score
        global pacdot_counter
        dot_map.dots_map[self.matrix_position()[0]][self.matrix_position()[1]] = pacmap.DotTile.NDT
        pacdot_counter -= 1
        score += 10
        if pacdot_counter == 0:
            game_over("win")

    def eat_super_pacdot(self, dot_map):
        global score
        dot_map.dots_map[self.matrix_position()[0]][self.matrix_position()[1]] = pacmap.DotTile.NDT
        score += 50
        self.super_power += 1

        # TODO
        # Requires UNIX
        #pid = os.fork()
        #if pid == 0:
        #    return
        
        #os.sleep(10)
        self.super_power -= 1
        self.ghost_combo = 0
        #os._exit(0)

    def eat_fruit(self, fruit, dot_map):
        global score
        dot_map.dots_map[self.matrix_position()[0]][self.matrix_position()[1]] = pacmap.DotTile.NDT
        score += fruit.score

    def eat_ghost(self, ghost):
        global score
        ghost.despawn_and_respawn()
        self.ghost_combo += 1
        score += (2 ** self.ghost_combo) * 100

    def get_eaten(self, dot_map):
        global lives
        #TODO score loss ?
        self.position = dot_map.spawn_point #TODO
        lives -= 1
        if lives < 0: # à vérifier
            game_over()

    def change_dir(self, new_dir):
        self.direction = new_dir
    
    def move(self):
        # self.position[0] += self.direction[0] * self.speed
        # self.position[1] += self.direction[1] * self.speed
        self.position[0] = (self.position[0] + self.direction[0]) % (self.resolution * self.map_size[0])
        self.position[1] = (self.position[1] + self.direction[1]) % (self.resolution * self.map_size[1])

def game_over(status = "lose"):
    #TODO
    pass






